| LUFA Library 140302 |

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Functions
SPI Peripheral Driver (XMEGA)
SPI Driver - LUFA/Drivers/Peripheral/SPI.h

## Functions
static void | SPI_Disable (SPI_t *const SPI) ATTR_NON_NULL_PTR_ARG(1)
static uint8_t | SPI_GetCurrentMode (SPI_t *const SPI) ATTR_ALWAYS_INLINE ATTR_NON_NULL_PTR_ARG(1)
static void | SPI_Init (SPI_t *const SPI, const uint8_t SPIOptions) ATTR_NON_NULL_PTR_ARG(1)
static uint8_t | SPI_ReceiveByte (SPI_t *const SPI) ATTR_ALWAYS_INLINE ATTR_WARN_UNUSED_RESULT ATTR_NON_NULL_PTR_ARG(1)
static void | SPI_SendByte (SPI_t *const SPI, const uint8_t Byte) ATTR_ALWAYS_INLINE ATTR_NON_NULL_PTR_ARG(1)
static uint8_t | SPI_TransferByte (SPI_t *const SPI, const uint8_t Byte) ATTR_ALWAYS_INLINE ATTR_NON_NULL_PTR_ARG(1)

## SPI Prescaler Configuration Masks
#define | SPI_SPEED_FCPU_DIV_2 SPI_USE_DOUBLESPEED
#define | SPI_SPEED_FCPU_DIV_4 0
#define | SPI_SPEED_FCPU_DIV_8 (SPI_USE_DOUBLESPEED | (1 << SPI_PRESCALER_gp))
#define | SPI_SPEED_FCPU_DIV_16 (1 << SPI_PRESCALER_gp)
#define | SPI_SPEED_FCPU_DIV_32 (SPI_USE_DOUBLESPEED | (2 << SPI_PRESCALER_gp))
#define | SPI_SPEED_FCPU_DIV_64 (2 << SPI_PRESCALER_gp)
#define | SPI_SPEED_FCPU_DIV_128 (3 << SPI_PRESCALER_gp)

## SPI SCK Polarity Configuration Masks
#define | SPI_SCK_LEAD_RISING 0
#define | SPI_SCK_LEAD_FALLING SPI_MODE1_bm

## SPI Sample Edge Configuration Masks
#define | SPI_SAMPLE_LEADING 0
#define | SPI_SAMPLE_TRAILING SPI_MODE0_bm

## SPI Data Ordering Configuration Masks
#define | SPI_ORDER_MSB_FIRST 0
#define | SPI_ORDER_LSB_FIRST SPI_DORD_bm

## SPI Mode Configuration Masks
#define | SPI_MODE_SLAVE 0
#define | SPI_MODE_MASTER SPI_MASTER_bm

## Detailed Description

# Module Description

Driver for the hardware SPI port(s) available on XMEGA AVR microcontroller models. This module provides an easy to use driver for the setup and transfer of data over the AVR's SPI ports.

Note
  This file should not be included directly. It is automatically included as needed by the SPI driver dispatch header located in LUFA/Drivers/Peripheral/SPI.h.

// Initialize the SPI driver before first use
SPI_Init(&SPIC,
SPI_SPEED_FCPU_DIV_2 | SPI_ORDER_MSB_FIRST | SPI_SCK_LEAD_FALLING |
SPI_SAMPLE_TRAILING | SPI_MODE_MASTER);
// Send several bytes, ignoring the returned data
SPI_SendByte(&SPIC, 0x01);
SPI_SendByte(&SPIC, 0x02);
SPI_SendByte(&SPIC, 0x03);
// Receive several bytes, sending a dummy 0x00 byte each time
uint8_t Byte1 = SPI_ReceiveByte(&SPIC);
uint8_t Byte2 = SPI_ReceiveByte(&SPIC);
uint8_t Byte3 = SPI_ReceiveByte(&SPIC);
// Send a byte, and store the received byte from the same transaction
uint8_t ResponseByte = SPI_TransferByte(&SPIC, 0xDC);

## Macro Definition Documentation

#define SPI_MODE_MASTER SPI_MASTER_bm

SPI mode mask for SPI_Init(). Indicates that the SPI interface should be initialized into master mode.

#define SPI_MODE_SLAVE 0

SPI mode mask for SPI_Init(). Indicates that the SPI interface should be initialized into slave mode.

#define SPI_ORDER_LSB_FIRST SPI_DORD_bm

SPI data order mask for SPI_Init(). Indicates that data should be shifted out LSB first.

#define SPI_ORDER_MSB_FIRST 0

SPI data order mask for SPI_Init(). Indicates that data should be shifted out MSB first.

#define SPI_SAMPLE_LEADING 0

SPI data sample mode mask for SPI_Init(). Indicates that the data should sampled on the leading edge.

#define SPI_SAMPLE_TRAILING SPI_MODE0_bm

SPI data sample mode mask for SPI_Init(). Indicates that the data should be sampled on the trailing edge.

#define SPI_SCK_LEAD_FALLING SPI_MODE1_bm

SPI clock polarity mask for SPI_Init(). Indicates that the SCK should lead on the falling edge.

#define SPI_SCK_LEAD_RISING 0

SPI clock polarity mask for SPI_Init(). Indicates that the SCK should lead on the rising edge.

#define SPI_SPEED_FCPU_DIV_128 (3 << SPI_PRESCALER_gp)

SPI prescaler mask for SPI_Init(). Divides the system clock by a factor of 128.

#define SPI_SPEED_FCPU_DIV_16 (1 << SPI_PRESCALER_gp)

SPI prescaler mask for SPI_Init(). Divides the system clock by a factor of 16.

#define SPI_SPEED_FCPU_DIV_2 SPI_USE_DOUBLESPEED

SPI prescaler mask for SPI_Init(). Divides the system clock by a factor of 2.

#define SPI_SPEED_FCPU_DIV_32 (SPI_USE_DOUBLESPEED | (2 << SPI_PRESCALER_gp))

SPI prescaler mask for SPI_Init(). Divides the system clock by a factor of 32.

#define SPI_SPEED_FCPU_DIV_4 0

SPI prescaler mask for SPI_Init(). Divides the system clock by a factor of 4.

#define SPI_SPEED_FCPU_DIV_64 (2 << SPI_PRESCALER_gp)

SPI prescaler mask for SPI_Init(). Divides the system clock by a factor of 64.

#define SPI_SPEED_FCPU_DIV_8 (SPI_USE_DOUBLESPEED | (1 << SPI_PRESCALER_gp))

SPI prescaler mask for SPI_Init(). Divides the system clock by a factor of 8.

## Function Documentation

static void SPI_Disable | ( | SPI_t *const | SPI | ) |
| inline static

Turns off the SPI driver, disabling and returning used hardware to their default configuration.

Parameters

  [in,out] | SPI | Pointer to the base of the SPI peripheral within the device.

static uint8_t SPI_GetCurrentMode | ( | SPI_t *const | SPI | ) |
| inline static

Retrieves the currently selected SPI mode, once the SPI interface has been configured.

Parameters

  [in,out] | SPI | Pointer to the base of the SPI peripheral within the device.

Returns
  SPI_MODE_MASTER if the interface is currently in SPI Master mode, SPI_MODE_SLAVE otherwise

static void SPI_Init | ( | SPI_t *const | SPI,
|  | const uint8_t | SPIOptions
| ) |  |
| inline static

Initializes the SPI subsystem, ready for transfers. Must be called before calling any other SPI routines.

Parameters

  [in,out] | SPI | Pointer to the base of the SPI peripheral within the device.
  [in] | SPIOptions | SPI Options, a mask consisting of one of each of the `SPI_SPEED_*`, `SPI_SCK_*`, `SPI_SAMPLE_*`, `SPI_ORDER_*` and `SPI_MODE_*` masks.

static uint8_t SPI_ReceiveByte | ( | SPI_t *const | SPI | ) |
| inline static

Sends a dummy byte through the SPI interface, blocking until the transfer is complete. The response byte from the attached SPI device is returned.

Parameters

  [in,out] | SPI | Pointer to the base of the SPI peripheral within the device.

Returns
  The response byte from the attached SPI device.

static void SPI_SendByte | ( | SPI_t *const | SPI,
|  | const uint8_t | Byte
| ) |  |
| inline static

Sends a byte through the SPI interface, blocking until the transfer is complete. The response byte sent to from the attached SPI device is ignored.

Parameters

  [in,out] | SPI | Pointer to the base of the SPI peripheral within the device.
  [in] | Byte | Byte to send through the SPI interface.

static uint8_t SPI_TransferByte | ( | SPI_t *const | SPI,
|  | const uint8_t | Byte
| ) |  |
| inline static

Sends and receives a byte through the SPI interface, blocking until the transfer is complete.

Parameters

  [in,out] | SPI | Pointer to the base of the SPI peripheral within the device.
  [in] | Byte | Byte to send through the SPI interface.

Returns
  Response byte from the attached SPI device.